#!/bin/sh
# ~/.icewm/icewm-menu4.sh
# Objectif : construire un menu bilingue (FR, EN) pour icewm. |
# Goal : build a bilingual (EN, FR) menu for icewm.
#
# © Christian L'Écuyer, Gatineau (Qc), Canada, sam. 28 janv. 2017, 00:03; GPL3.
#  (Alias « musher0 » [forum Puppy].) # Rév. 2017-09-02 & 03, 10-23, 11-24, 12-26; 2018-01-03.
################# 	# https://opensource.org/licenses/GPL-3.0
#    This program is free software: you can redistribute it and/or modify it under the
#    terms of the GNU General Public License as published by the Free Software
#    Foundation, either version 3 of the License, or  (at your option) any later version.
#    	This program is distributed in the hope that it will be useful, but WITHOUT ANY
#    WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
#    A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#    	You should have received a copy of the GNU General Public License along with
#   this program. If not, see <http://www.gnu.org/licenses/>.
##########
#   Ce programme est libre : vous pouvez le redistribuer ou modifier selon les termes
#   de la Licence Publique Générale GNU publiée par la Free Software Foundation (v. 3
#   ou toute version ultérieure choisie par vous).
#       Ce programme est distribué dans l'espoir qu'il sera utile, mais SANS AUCUNE
#   GARANTIE, ni explicite ni implicite, y compris des garanties de commercialisation
#   ou d'adaptation à un but spécifique. Pour plus de détails, veuillez vous reporter
#   au texte officiel de cette licence à https://opensource.org/licenses/GPL-3.0, à
#   http://www.linux-france.org/article/these/gpl.html pour une traduction et, pour une
#   explication en français, à https://fr.wikipedia.org/wiki/Licence_publique_générale_GNU.
################
#### set -xe
# export LANG=en_CA.utf8 # To test. Otherwise it is automatic.
LC_ALL=C
if [ "`ps | awk '$4=="icewm" { print $4 }'`" -a "`cat /etc/windowmanager`" != "icewm" ];then
	echo "icewm" > /etc/windowmanager
fi

# We try not to do this often. / On essaie de ne pas faire ça souvent.
if [ ! -f /root/.icewm/menu ];then a=1
else [ "`ls -Algo ~/.icewm/icewm-menu4.sh | awk '{ print $3 }'`" = "`cat ~/.icewm/menu.size`" ] && a=0 || a=1
fi

[ "`ls -Algo /usr/share/applications/*.desktop | wc -l`" = "`cat /usr/share/applications/combien`" ] && b=0 || b=1

if [ ! -f /root/.icewm/Other.size ];then c=1
else [ "`cat ~/.icewm/Other.size`" = "`ls -Algo /root/.icewm/Other.icewm | awk '{ print $3 }'`" ] && c=0 || c=1
fi

if [ ! -f ~/.icewm/Autres.size ];then d=1
else [ "`cat /root/.icewm/Autres.size`" = "`ls -Algo /root/.icewm/Autres.icewm | awk '{ print $3 }'`" ] && d=0 || d=1
fi

if [ ! -f ~/.icewm/menu.Defaults.icewm ];then e=1
else [ "`cat /root/.icewm/menu.Defaults.icewm.size`" = "`ls -Algo /root/.icewm/menu.Defaults.icewm`" ] && e=0 || e=1
fi

w="`echo "$[$a + $b +$c + $d +$e]"`" # echo $w
if [ "$w" -gt "0" ];then
	[ ! -f /root/.icewm/menu.Defaults.icewm ] && exec ~/.icewm/menu.Defaults.icewm.sh &

	SousMenu () { for i in `grep -H $CateG *.desktop | grep Categories | awk -F":" '{ print $1 }'`;
		do	IcoN="`awk -F= '$1=="Icon" { print $2 }' $i`";[ "$IcoN" = "" ] && IcoN="-"
			ExeC="`awk -F'=' '$1=="Exec" { print $2 }' $i`"
			if [[ ! "$ExeC" =~ "default" ]]; then	echo -e "\t\tprog \"${i%.*}\" \"$IcoN\" $ExeC" >> $txtDepart;fi
		done
		if [ "`wc -c < $txtDepart`" -gt "0" ];then echo -e "\tmenu $CateG - {\nseparator\nseparator\nseparator" >> $txtArrivee
#	prog \" --$CateG --\" - /root/.icewm/en-tete.sh\nseparator" >> $txtArrivee
			cat $txtDepart >> $txtArrivee;echo -e "\t\tseparator\n}\n" >> $txtArrivee
		fi; }

	CoLoR="bd AntiqueWhite2 -bg AntiqueWhite4 -fg white" # Avertissement
	if [ "${LANG:0:2}" = "fr" ];then TXTMSG3="
Le menu d'icewm
... se met à jour ..."
	else TXTMSG3="
The icewm menu
... is being updated ..."
	fi
	bcm -u /root/.icewm/icewm-inv.png -a 1 -g c:c -d 5 -b "#000000FF" -c "#0c0c0c8F" -t "<span font='AkizaSans Bold Italic 18' color='white' gravity='north' gravity_hint='line'>$TXTMSG3</span>" &

	cd /usr/share/applications # Création du menu
	txtArrivee="/root/.icewm/tmp.menu2";> $txtArrivee
	for CateG in Wizard Desktop Develop Monitor Network Setup System Utility # Emulat # Catégories "Configs"
	do	txtDepart="";txtDepart="/root/.icewm/tmp.config";> $txtDepart;SousMenu;done

	RPLCT="replaceit --input=$txtArrivee"
	for i in Menu JWM jwm restart pRun pRecent
# On enlève ce qui a trait à jwm, les redémarrages et les « pRmachins ».
	do $RPLCT --wholeline "$i" "#";done

	case "${LANG:0:2}" in fr)$RPLCT Desktop "Bureau" "{menu"
		$RPLCT Develop Développement "{menu";$RPLCT Network Réseau "{menu";$RPLCT Setup Paramétrage "{menu"
		$RPLCT System Système "{menu";$RPLCT Utility Utilitaires "{menu";	$RPLCT Wizard Assistants "{menu"
		$RPLCT Monitor Moniteurs "{menu" ;;

		en|*)$RPLCT Monitor Monitors "{menu" ;;
	esac

	txtArrivee="";txtArrivee="/root/.icewm/tmp.menu";> $txtArrivee # Catégories principales
	txtDepart="";txtDepart="/root/.icewm/tmp.categ"
	case "${LANG:0:2}" in
		fr)for CateG in Archiving Audio Business Calculate Database Document TextEditor File Fun Graphic Internet Game Multimedia Personal Video
			do	> $txtDepart;SousMenu;done ;;

		en|*)for CateG in Archiving Audio Business Calculate Database Document TextEditor File Fun Game Graphic Internet Multimedia Personal Video
			do	> $txtDepart;SousMenu;done ;;
	esac

	RPLCT="replaceit --input=$txtArrivee" # Pourquoi redite ???
	case "${LANG:0:2}" in fr)$RPLCT Archiving Archivage "{menu"
		$RPLCT Business Affaires "{menu";$RPLCT Personal Personnel "{menu";$RPLCT Calculate Calculs "{menu"
		$RPLCT Database BdD "{menu";$RPLCT Document Documents "{menu";$RPLCT File Fichiers "{menu"
		$RPLCT Fun Loisirs "{menu";$RPLCT Game Jeux "{menu";$RPLCT Graphic Graphiques "{menu"
		$RPLCT Multimedia Multimédia "{menu";$RPLCT TextEditor Éditeurs "{menu";$RPLCT Video Vidéo "{menu" ;;
	esac

	> $txtDepart # Approche différente pour les favoris
	txtArrivee="";txtArrivee="/root/.icewm/tmp.favoris";> $txtArrivee
	grep -H Favori *.desktop | grep Categor | awk -F"\." '{ print $1 }' >> $txtDepart
	while read line;do
		echo -e "\tprog $line - rox /usr/share/applications/$line.desktop" >> $txtArrivee
	done < $txtDepart

	case "${LANG:0:2}" in fr)FavS=Favoris;Autr=Autres ;;
		en|*)FavS=Favorites;Autr=Other ;;
	esac

	if [ ! -f /root/.icewm/aOO-LO.menu ];then > ~/.icewm/aOO-LO.menu # aOO | LO
		if [ -e /usr/bin/soffice ];then # BaseDir="/opt/openoffice4"
			IconDir=" /usr/share/icons/Icones-aOO-Gulfstream"
			echo -e "\tseparator\nmenu \"aOO | LO\" /opt/openoffice4/program/logo.png {
	separator" >> ~/.icewm/aOO-LO.menu
			for i in base calc draw impress web writer;do
				echo -e "\tprog $i $IconDir/ooo-$i.png soffice -$i" >> ~/.icewm/aOO-LO.menu
			done
			echo -e "separator\n}" >> ~/.icewm/aOO-LO.menu
		fi
	fi

	> ~/.icewm/menu # Assemblage
	case "${LANG:0:2}" in fr)Apps=Applis;LiseZ="Lisez-moi" ;;
		en|*)Apps=Apps;LiseZ="ReadMe" ;;
	esac
	echo -e "# menu | icewm | menu # par / by musher0 # 2017/01/28\n#
menu $Apps - {\nseparator\nseparator\n`cat ~/.icewm/tmp.menu`\nseparator\n}\n\n
menu Configs - {\nseparator\nseparator\n`cat ~/.icewm/tmp.menu2`\nseparator\n}\n
menu $FavS - {\nseparator\nseparator\n`cat ~/.icewm/tmp.favoris`\nseparator\n}\n
menu $Autr - {\nseparator\nseparator\n`cat ~/.icewm/$Autr.icewm`\nseparator\n}\n
`cat ~/.icewm/menu.Defaults.icewm`
`cat ~/.icewm/aOO-LO.menu`" >> ~/.icewm/menu

	case "${LANG:0:2}" in fr)cat ~/.icewm/menu.bas >> ~/.icewm/menu;Redem="Redém. avec" ;;
		en|*)cat ~/.icewm/menu.bottom >> ~/.icewm/menu;Redem="Restart with" ;;
	esac

	while read line;do if [ "`which $line`" ];then
			[ "$line" = "icewm" ] && echo "#" >> ~/.icewm/menu || echo "prog \"$Redem $line\" mini-windows restartwm $line" >> ~/.icewm/menu
		fi;done < ~/.icewm/WM.lst2
	echo -e "separator\n}\n### 30 ###" >> ~/.icewm/menu

	rm -f /root/.icewm/tmp.*;cp -f /root/.icewm/menu /root/.icewm/menu.bckp

# Vérif
	if [ ! -f /root/.icewm/menu.size -o "`cat /root/.icewm/menu.size`" != "`ls -Algo /root/.icewm/icewm-menu4.sh | awk '{ print $3 }'`" ];then
		ls -Algo /root/.icewm/icewm-menu4.sh | awk '{ print $3 }' > /root/.icewm/menu.size
	fi

	if [ ! -f /root/.icewm/Other.size -o "`cat /root/.icewm/Other.size`" != "`ls -Algo /root/.icewm/Other.icewm | awk '{ print $3 }'`" ];then
		ls -Algo /root/.icewm/Other.icewm | awk '{ print $3 }' > /root/.icewm/Other.size
	fi

	if [ ! -f /root/.icewm/Autres.size -o "`cat /root/.icewm/Autres.size`" != "`ls -Algo /root/.icewm/Autres.icewm | awk '{ print $3 }'`" ];then
		ls -Algo /root/.icewm/Autres.icewm | awk '{ print $3 }' > /root/.icewm/Autres.size
	fi

	[ ! -f /usr/share/applications/combien ] && ls -Algo /usr/share/applications/*.desktop | wc -l > /usr/share/applications/combien

	[ ! -f /root/.icewm/menu.Defaults.icewm.size ] && ls -Algo /root/.icewm/menu.Defaults.icewm > /root/.icewm/menu.Defaults.icewm.size

# export LANG=fr_CA.utf8 # To test. Otherwise it is automatic.
	LC_ALL=""
else
	CoLoR="bd AntiqueWhite2 -bg AntiqueWhite4 -fg white" # Avertissement
	if [ "${LANG:0:2}" = "fr" ];then TXTMSG3="
Aucun changement."
	else TXTMSG3="
No change."
	fi
	bcm -u /root/.icewm/icewm-inv.png -a 1 -g c:c -d 2 -b "#000000FF" -c "#0c0c0c8F" -t "<span font='AkizaSans Bold Italic 18' color='white' gravity='north' gravity_hint='line'>$TXTMSG3</span>" &
fi
#################################
## Notes -- (Français) # Le menu FR prend +/- 3,9 sec. à se construire.
#
# Ajouter à la fin de /usr/sbin/fixmenus (après la série de « which ») la ligne :
# [ "`cat /etc/windowmanager`" = "icewm" ] && /root/.icewm/icewm-menu?.sh
#
# Ajouter cette même ligne juste avant la ligne qui dit « ##w468 rox may not
# start old... » (vers la ligne 173; après la section sur lxpanel) dans /root/.xinitrc.
#
# La ligne « Exec= » des fichiers *.desktop pour Open|LibreOffice devraient utiliser
# la forme abrégée, telle que : Exec=/opt/libreoffice-5.3/program/swriter.
#
# Certaines « Catégories » ont dû être généralisées pour que le présent script
# fonctionne. S.v.p. voir les exemples dans l'archive.
#
########
## Notes -- (English) # The EN menu takes +/- 2.6 sec. to build.
#
# Add at the bottom of /usr/sbin/fixmenus (after the series of "which") the line:
# [ "`cat /etc/windowmanager`" = "icewm" ] && /root/.icewm/icewm-menu?.sh
#
# Add that same line just before the line that says "##w468 rox may not start old..."
# (+/- at line 173; after the lxpanel section) in /root/.xinitrc.
#
# The "Exec=" line of the *.desktop files for Open|LibreOffice should use the short
# form of the command, such as: Exec=/opt/libreoffice-5.3/program/swriter.
#
# Certain "Categories" had to be generalized for this script to work. Please see
# the examples in the archive.
#
################################# set +xe
