#!/bin/ash
# ~/.icewm/menu.Default.icewm2.sh
# Objectif : construire un menu icewm pour les programmes par défaut de PuppyLinux. |
# Goal : build an icewm menu for the PuppyLinux default apps.
#
# © Christian L'Écuyer, Gatineau (Qc), Canada, sam. 26 déc. 2017; GPL3.
#  (Alias « musher0 » [forum Puppy].) ## Rév. 6 janv. 2018
################# 	# https://opensource.org/licenses/GPL-3.0
#    This program is free software: you can redistribute it and/or modify it under the
#    terms of the GNU General Public License as published by the Free Software
#    Foundation, either version 3 of the License, or  (at your option) any later version.
#    	This program is distributed in the hope that it will be useful, but WITHOUT ANY
#    WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
#    A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#    	You should have received a copy of the GNU General Public License along with
#   this program. If not, see <http://www.gnu.org/licenses/>.
##########
#   Ce programme est libre : vous pouvez le redistribuer ou modifier selon les termes
#   de la Licence Publique Générale GNU publiée par la Free Software Foundation (v. 3
#   ou toute version ultérieure choisie par vous).
#       Ce programme est distribué dans l'espoir qu'il sera utile, mais SANS AUCUNE
#   GARANTIE, ni explicite ni implicite, y compris des garanties de commercialisation
#   ou d'adaptation à un but spécifique. Pour plus de détails, veuillez vous reporter
#   au texte officiel de cette licence à https://opensource.org/licenses/GPL-3.0, à
#   http://www.linux-france.org/article/these/gpl.html pour une traduction et, pour une
#   explication en français, à https://fr.wikipedia.org/wiki/Licence_publique_générale_GNU.
################ # set -xe
# export LANG=en_CA.utf8 # To test. Otherwise it is automatic.
ProgLine () { echo -e "\t\tprog ${line#*t} - $line" >> ~/.icewm/menu.Defaults.icewm.tmp; }

# Précaution pour quand icewm a été lancé d'un gest. de fen. (par ex., waimea) qui en lance
# un autre directement sans qu'ait été modifié également le fichier /etc/windowmanager. |
# Precaution for when icewm has been launched directly by another WM (e.g. waimea)
# without file /etc/windowmanager having been modified as well.
[ "`pgrep icewm`" -a "`cat /etc/windowmanager`" != "icewm" ] && echo "icewm" > /etc/windowmanager
if [ "`cat /etc/windowmanager`" = "icewm" ];then LC_ALL=C
	cd /usr/local/bin
	ls -Algo --file-type default* | awk '$1 !~ /lrw/ && $NF !~ /lts-|run|cdr$|handler/ { print $NF }' > /root/.icewm/default-progs

	> ~/.icewm/menu.Defaults.icewm.tmp
	while read line;do ProgLine;done < /tmp/default-progs

	case "${LANG:0:2}" in fr) # Il est plus pratique de traduire avant de faire la division.
			RPLCT="replaceit --input=/root/.icewm/menu.Defaults.icewm.tmp"
$RPLCT archiver archiveur "}default" "{prog";$RPLCT audiomixer mixeur "}default" "{prog"
$RPLCT browser navigateur "}default" "{prog";$RPLCT calendar calendrier "}default" "{prog"
$RPLCT chat clavardage "}default" "{prog";$RPLCT connect connexion "}default" "{prog"
$RPLCT draw "\"éd. de dessin\"" "}default" "{prog";$RPLCT email courriel "}default" "{prog"
$RPLCT paint "\"éd. d'image\"" "}default" "{prog";$RPLCT screenshot captures "}default" "{prog"
$RPLCT spreadsheet chiffrier "}default" "{prog";	$RPLCT audioeditor "\"éd. audio\"" "}default" "{prog"
$RPLCT audioplayer "\"lect. audio\"" "}default" "{prog";	$RPLCT cdplayer "\"lect. CD\"" "}default" "{prog"
$RPLCT cdrecorder "\"enregistreur\"" "}default" "{prog";$RPLCT chmviewer "\"vis. de chm\"" "}default" "{prog"
$RPLCT filemanager "\"gest. de fich.\"" "}default" "{prog";$RPLCT htmleditor "\"éd. de html\"" "}default" "{prog"
$RPLCT pdfviewer "\"vis. de pdf" "}default\"" "{prog";$RPLCT htmlviewer "\"vis. de html\"" "}default" "{prog"
$RPLCT imageviewer "\"vis. d'image\"" "}default" "{prog";$RPLCT mediaplayer "\"lect. média\"" "}default" "{prog"
$RPLCT processmanager "\"gest. de proc.\"" "}default" "{prog"
$RPLCT texteditor "\"éd. de texte\"" "}default" "{prog";$RPLCT textviewer "\"vis. de texte\"" "}default" "{prog"
$RPLCT wordprocessor "\"tr. de texte\"" "}default" "{prog"
			sort /root/.icewm/menu.Defaults.icewm.tmp > /root/.icewm/menu.Defaults.icewm # Tri nécessaire
			sleep 0.2s
			rm -f /root/.icewm/menu.Defaults.icewm.tmp
			Defaut="par défaut";Refr="Rafraîchir" ;;
		en|*)
			mv -f /root/.icewm/menu.Defaults.icewm.tmp /root/.icewm/menu.Defaults.icewm
			Defaut="by default";Refr="Refresh" ;;
	esac

	head -n 14 /root/.icewm/menu.Defaults.icewm > /root/.icewm/default-progs1;sleep 0.1s
	tail -n 14 /root/.icewm/menu.Defaults.icewm > /root/.icewm/default-progs2

	echo -e "menu \"$Defaut\" - {\n\tseparator
	menu \"a...\" - {\n\t\tseparator\n\t\tseparator\n`cat /root/.icewm/default-progs1`
\t\tseparator\n\t}\n
\tmenu \"f...\" - {\n\t\tseparator\n\t\tseparator\n`cat /root/.icewm/default-progs2`
\t\tseparator\n\t}
\tprog $Refr - /root/.icewm/menu.Defaults.icewm.sh
\tseparator\n}" > ~/.icewm/menu.Defaults.icewm # Actual defaults menu creation
	rm -f /root/.icewm/default-progs*
	LC_ALL=""
# export LANG=fr_CA.utf8 # To test. Otherwise it is automatic. # set +xe
fi
